#!/usr/bin/env ruby

=begin
WPScan - WordPress Security Scanner
Copyright (C) 2011  Ryan Dewhurst AKA ethicalhack3r

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.

ryandewhurst at gmail
=end

class Bruter

  attr_accessor :url, :usernames, :wordlist, :threads, :verbose

  def initialize(url,usernames,wordlist,threads,verbose)
    @url = url + 'wp-login.php'
    @usernames = usernames
    @wordlist = wordlist
    @threads = threads
    @verbose = verbose
  end

  def brute

    # create the hydra object    

    hydra = Typhoeus::Hydra.new(:max_concurrency => @threads)

    hydra.disable_memoization

    # create a hash that contains an array of passwords

    credentials = {}
    @usernames.each do |username|
      File.open(@wordlist, "r") do |f|
        passwords = f.readlines
        credentials[username] = passwords
      end
    end

    # create a request object for every user/pass pair

    request_count = 0
    queue_count = 0

    credentials.each_pair do |user,pass|

      password_found = false
      invalid_username = false

      puts 'Brute forcing ' + user + ' with ' + credentials[user].size.to_s + ' passwods...' 
  
      pass.each do |pass|

        # ignore file comments, but will miss passwords if they start with a hash...

        next if pass[0,1] == '#'

        # keep a count of the amount of requests to be sent
     
        request_count += 1
        queue_count += 1

        # the request object

        request = Typhoeus::Request.new(@url.to_s,
                                        :method        => :post,
                                        :params        => {:log => user, :pwd => pass})
        # we can see from this that the first argument is the url. the second is a set of options.
        # the options are all optional. The default for :method is :get. Timeout is measured in milliseconds.
        # cache_timeout is measured in seconds.

        # tell hydra what to do when the request completes

        request.on_complete do |response|
          if response.body =~ /invalid username/i
            puts "ERROR: Invalid username! Moving onto the next username..."
            invalid_username = true
          elsif response.body =~ /the password you entered for the username/i or response.body =~ /incorrect password/i
            puts "Trying Username:" + user + " Password:#{pass}" if @verbose
          elsif response.body =~ /the password field is empty/i
            puts "ERROR: We sent a blank password."
          elsif response.code == 302
            puts "SUCCESS! Username:" + user + " Password:#{pass}"
            puts
            password_found = true
          else
            puts "ERROR: We recieved an unknown response..."
            if @verbose
              puts 'Code: ' + response.code.to_s
              puts 'Body: ' + response.body
              puts
             end
          end
        end    
  
        # move onto the next username if we have found a valid password
        next if password_found

        # move on if we encountered an invalid username error
        next if invalid_username

        # queue the request to be sent later

        hydra.queue(request)  

        # it can take a long time to queue 2 million requests,
        # for that reason, we queue @threads, send @threads, queue @threads and so on.
        # hydra.run only returns when it has recieved all of its,
        # responses. This means that while we are waiting for @threads,
        # responses, we are waiting...

        if queue_count >= @threads
          hydra.run
          queue_count = 0
          puts 'Sent ' +  @threads.to_s + ' requests.... ' if @verbose
        end

      end

    end

    # run all of the remaining requests that are left over

    hydra.run

  end

end
